#!/usr/local/bin/clisp
;
; Notify Daemon (login as grid and type "./notify_bsd.lisp &" to start)
; Simple Grid Protocol 1.0 - Copyright (c) Brendan Kosowski 2004
;
(defvar c)
(defvar n)
(defvar fr)
(defvar subst)
(defvar slist)
(defvar idle)
(defvar token)
(defvar my_ip)
(defvar track_ip)
(defvar cpu_freq)
(defvar cprev)
(defvar lin)
(defvar stm)
(defvar acr)
(defvar flist)
(defvar topcommand "top -b -d2 -s30 0 > /home/grid/top.dat")

(defun file-to-list (file)
	(setq fr (open file :direction :input))
	(setq c #\space)
	(setq slist NIL)
	(setq subst "")
	(loop
		(setq cprev c)
		(setq c (read-char fr nil))
		(unless c (return))
		(if (or (char= c #\space) (char= c #\newline))
			(when (and (char/= cprev #\space) (char/= cprev #\newline)) (push subst slist) (setq subst ""))
			(setq subst (concatenate 'string subst (string c)))
		)
	)
	(close fr)
	(if (string/= subst "") (push subst slist))
	(reverse slist)
)

(setq fr (open "/home/grid/token.dat" :direction :input))
(setq token (read-line fr))
(close fr)

(setq fr (open "/home/grid/my_ip.dat" :direction :input))
(setq my_ip (read-line fr))
(close fr)

(setq fr (open "/home/grid/track_ip.dat" :direction :input))
(setq track_ip (read-line fr))
(close fr)

(setq fr (open "/home/grid/cpu_freq.dat" :direction :input))
(setq cpu_freq (read-from-string (read-line fr)))
(close fr)

(loop
	(ext:shell topcommand)
	(setq flist (file-to-list "top.dat"))
	(setq n (position "idle" flist :from-end t :test #'string=))
	(setq idle (read-from-string (string-right-trim "%" (nth (- n 1) flist))))

	(setq acr (* cpu_freq (/ idle 100)))

	(setq stm (socket:socket-connect 17667 track_ip))
	(read-line stm)

	(setq lin (read-line stm))
	(when (string= lin "token?")
		(format stm "~a~%" token)
	)

	(setq lin (read-line stm))
	(when (string= lin "what?")
		(format stm "join~%")
	)

	(setq lin (read-line stm))
	(when (string= lin "ip?")
		(format stm "~a~%" my_ip)
	)

	(setq lin (read-line stm))
	(when (string= lin "acr?")
		(format stm "~a~%" acr)
	)

	(setq lin (read-line stm))
	(when (string= lin "what?")
		(format stm "bye~%")
	)

	(close stm)
)
